﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.3
@EndOfDesignText@
private Sub Class_Globals
	Public CUBE_ANIM As Int = 0
	Public FLIP_ANIM As Int = 1
	Public MOVE_ANIM As Int = 2
	Public SIDES_ANIM As Int = 3
	Public PUSHPULL_ANIM As Int = 4
	Private AnimationType As Int = 0

	Dim Fragment As Amir_Fragment
	Private Animation As Amir_FragmentAnimation
	Private p As Panel
	Private mDirection As Int
	Private Label As Label

	Private Custom As Object
End Sub

Public Sub Initialize (Content As Panel,Direction As Int,AnimType As Int,CustomAnimation As Object)
	p=Content
	Custom = CustomAnimation
	AnimationType=AnimType
	mDirection=Direction
	Fragment.Initialize("Amir","")
End Sub

Private Sub Amir_onCreateAnimation (Transit As Int, Enter As Boolean,NextAnim As Int) As Object
	If Custom<>Null Then Return Custom
	If mDirection=-1 Then Return Null
	Select AnimationType
		Case CUBE_ANIM
			Return Animation.CubeAnimation(mDirection,Enter,500)
		Case FLIP_ANIM
			Return Animation.FlipAnimation(mDirection,Enter,500)
		Case MOVE_ANIM
			Return Animation.MoveAnimation(mDirection,Enter,500)
		Case SIDES_ANIM
			Return Animation.SidesAnimation(mDirection,Enter,500)
		Case PUSHPULL_ANIM
			Return Animation.PushPullAnimation(mDirection,Enter,500)
	End Select
	Return Null
End Sub

Private Sub Amir_onCreateView (Parent As Panel)
	Parent.Width=p.Width
	Parent.Height=p.Height
	Parent.Color=Colors.RGB(Rnd(0,255),Rnd(0,255),Rnd(0,255))
	
	Label.Initialize("")
	Parent.AddView(Label,0,0,Parent.Width,Parent.Height)
	Label.TextColor=Colors.White
	Label.Text=AnimTypeToString(AnimationType)
	Label.TextSize=18
	Label.Gravity=Gravity.CENTER
	
	Dim IconSize As Int = 56dip
	
	Dim Top As Label
	Top.Initialize("Click")
	InitIcon(Top,Animation.DIRECTION_UP)
	Parent.AddView(Top,Parent.Width/2-IconSize/2,0,IconSize,IconSize)
	
	Dim Down As Label
	Down.Initialize("Click")
	InitIcon(Down,Animation.DIRECTION_DOWN)
	Parent.AddView(Down,Parent.Width/2-IconSize/2,Parent.Height-IconSize,IconSize,IconSize)
	
	Dim Left As Label
	Left.Initialize("Click")
	InitIcon(Left,Animation.DIRECTION_LEFT)
	Parent.AddView(Left,0,Parent.Height/2-IconSize/2,IconSize,IconSize)
	
	Dim Right As Label
	Right.Initialize("Click")
	InitIcon(Right,Animation.DIRECTION_RIGHT)
	Parent.AddView(Right,Parent.Width-IconSize,Parent.Height/2-IconSize/2,IconSize,IconSize)
End Sub

Private Sub InitIcon (Lbl As Label,Direction As Int)
	Lbl.TextColor=Colors.White
	Lbl.Gravity=Gravity.CENTER
	Lbl.TextSize=22
	Lbl.Typeface=Typeface.MATERIALICONS
	Lbl.Tag=Direction
	Select Direction
		Case Animation.DIRECTION_UP
			Lbl.Text=Chr(0xE316)
		Case Animation.DIRECTION_DOWN
			Lbl.Text=Chr(0xE313)
		Case Animation.DIRECTION_LEFT
			Lbl.Text=Chr(0xE314)
		Case Animation.DIRECTION_RIGHT
			Lbl.Text=Chr(0xE315)
	End Select
End Sub

Private Sub AnimTypeToString (Types As Int) As String
	Select Types
		Case CUBE_ANIM
			Return "Cube"
		Case FLIP_ANIM
			Return "Flip"
		Case MOVE_ANIM
			Return "Move"
		Case SIDES_ANIM
			Return "Sides"
		Case PUSHPULL_ANIM
			Return "PushPull"
	End Select
	Return ""
End Sub

Private Sub Click_Click
	Dim V As View = Sender
	Dim FT As Amir_FragmentTransaction
	FT.Initialize
	Dim MyF As MyFragment
	mDirection=V.Tag
	MyF.Initialize(p,V.Tag,AnimationType,Null)
	CallSubDelayed2(Main,"UpdateSelected",MyF)
	FT.Replace3(p,MyF.Fragment)
	FT.Commit
End Sub

Public Sub UpdateAnim (AnimationName As String)
	Select AnimationName
		Case "Cube"
			AnimationType=CUBE_ANIM
		Case "Flip"
			AnimationType=FLIP_ANIM
		Case "Move"
			AnimationType=MOVE_ANIM
		Case "Sides"
			AnimationType=SIDES_ANIM
		Case "PushPull"
			AnimationType=PUSHPULL_ANIM
	End Select
	Label.Text=AnimationName
End Sub